diff --git a/vl.c b/vl.c
index e2e1393..432bc06 100644
--- a/vl.c
+++ b/vl.c
@@ -3015,7 +750,7 @@ int main_loop(void *opaque)
         /* poll any events */
         serial_ufd = NULL;
         pf = ufds;
-        if (serial_ok && !(serial_ports[0].lsr & UART_LSR_DR)) {
+        if (serial_ok && serial_can_receive()) {
             serial_ufd = pf;
             pf->fd = 0;
             pf->events = POLLIN;
@@ -3023,7 +758,7 @@ int main_loop(void *opaque)
         }
 #if defined (TARGET_I386)
         net_ufd = NULL;
-        if (net_fd > 0 && ne2000_can_receive(&ne2000_state)) {
+        if (net_fd > 0 && ne2000_can_receive()) {
             net_ufd = pf;
             pf->fd = net_fd;
             pf->events = POLLIN;
@@ -3043,7 +778,7 @@ int main_loop(void *opaque)
             if (serial_ufd && (serial_ufd->revents & POLLIN)) {
                 n = read(0, &ch, 1);
                 if (n == 1) {
-                    serial_received_byte(&serial_ports[0], ch);
+                    term_received_byte(ch);
                 } else {
 		    /* Closed, stop polling. */
                     serial_ok = 0;
@@ -3059,7 +794,7 @@ int main_loop(void *opaque)
                         memset(buf + n, 0, 60 - n);
                         n = 60;
                     }
-                    ne2000_receive(&ne2000_state, buf, n);
+                    ne2000_receive(buf, n);
                 }
             }
 #endif
@@ -3080,10 +815,7 @@ int main_loop(void *opaque)
             pic_set_irq(0, 1);
             pic_set_irq(0, 0);
             timer_irq_pending = 0;
-            /* XXX: RTC test */
-            if (cmos_data[RTC_REG_B] & 0x50) {
-                pic_set_irq(8, 1);
-            }
+            rtc_timer();
 #endif
         }
         /* XXX: add explicit timer */
@@ -3199,7 +931,7 @@ static uint8_t *signal_stack;
 
 int main(int argc, char **argv)
 {
-    int c, ret, initrd_size, i, use_gdbstub, gdbstub_port, long_index;
+    int c, i, use_gdbstub, gdbstub_port, long_index;
     int snapshot, linux_boot;
     struct sigaction act;
     struct itimerval itv;
@@ -3207,7 +939,6 @@ int main(int argc, char **argv)
     const char *initrd_filename;
     const char *hd_filename[MAX_DISKS], *fd_filename[MAX_FD];
     const char *kernel_filename, *kernel_cmdline;
-    char buf[1024];
     DisplayState *ds = &display_state;
 
     /* we never want that malloc() uses mmap() */
@@ -3438,92 +1169,7 @@ int main(int argc, char **argv)
     cpu_single_env = env;
 
     init_ioports();
-
-    /* allocate RAM */
-    cpu_register_physical_memory(0, ram_size, 0);
-
-#if defined(TARGET_I386)
-    /* RAW PC boot */
-
-    /* BIOS load */
-    snprintf(buf, sizeof(buf), "%s/%s", bios_dir, BIOS_FILENAME);
-    ret = load_image(buf, phys_ram_base + 0x000f0000);
-    if (ret != 0x10000) {
-        fprintf(stderr, "qemu: could not load PC bios '%s'\n", buf);
-        exit(1);
-    }
-    
-    /* VGA BIOS load */
-    snprintf(buf, sizeof(buf), "%s/%s", bios_dir, VGABIOS_FILENAME);
-    ret = load_image(buf, phys_ram_base + 0x000c0000);
-    
-    /* setup basic memory access */
-    cpu_register_physical_memory(0xc0000, 0x10000, 0xc0000 | IO_MEM_ROM);
-    cpu_register_physical_memory(0xf0000, 0x10000, 0xf0000 | IO_MEM_ROM);
-    
-    bochs_bios_init();
-
-    if (linux_boot) {
-        uint8_t bootsect[512];
-
-        if (bs_table[0] == NULL) {
-            fprintf(stderr, "A disk image must be given for 'hda' when booting a Linux kernel\n");
-            exit(1);
-        }
-        snprintf(buf, sizeof(buf), "%s/%s", bios_dir, LINUX_BOOT_FILENAME);
-        ret = load_image(buf, bootsect);
-        if (ret != sizeof(bootsect)) {
-            fprintf(stderr, "qemu: could not load linux boot sector '%s'\n",
-                    buf);
-            exit(1);
-        }
-
-        bdrv_set_boot_sector(bs_table[0], bootsect, sizeof(bootsect));
-
-        /* now we can load the kernel */
-        ret = load_kernel(kernel_filename, 
-                          phys_ram_base + KERNEL_LOAD_ADDR,
-                          phys_ram_base + KERNEL_PARAMS_ADDR);
-        if (ret < 0) {
-            fprintf(stderr, "qemu: could not load kernel '%s'\n", 
-                    kernel_filename);
-            exit(1);
-        }
-        
-        /* load initrd */
-        initrd_size = 0;
-        if (initrd_filename) {
-            initrd_size = load_image(initrd_filename, phys_ram_base + INITRD_LOAD_ADDR);
-            if (initrd_size < 0) {
-                fprintf(stderr, "qemu: could not load initial ram disk '%s'\n", 
-                        initrd_filename);
-                exit(1);
-            }
-        }
-        if (initrd_size > 0) {
-            stl_raw(phys_ram_base + KERNEL_PARAMS_ADDR + 0x218, INITRD_LOAD_ADDR);
-            stl_raw(phys_ram_base + KERNEL_PARAMS_ADDR + 0x21c, initrd_size);
-        }
-        pstrcpy(phys_ram_base + KERNEL_CMDLINE_ADDR, 4096,
-                kernel_cmdline);
-        stw_raw(phys_ram_base + KERNEL_PARAMS_ADDR + 0x20, 0xA33F);
-        stw_raw(phys_ram_base + KERNEL_PARAMS_ADDR + 0x22,
-                KERNEL_CMDLINE_ADDR - KERNEL_PARAMS_ADDR);
-        /* loader type */
-        stw_raw(phys_ram_base + KERNEL_PARAMS_ADDR + 0x210, 0x01);
-    }
-#elif defined(TARGET_PPC)
-    /* allocate ROM */
-    //        snprintf(buf, sizeof(buf), "%s/%s", bios_dir, BIOS_FILENAME);
-    snprintf(buf, sizeof(buf), "%s", BIOS_FILENAME);
-    printf("load BIOS at %p\n", phys_ram_base + 0x000f0000);
-    ret = load_image(buf, phys_ram_base + 0x000f0000);
-    if (ret != 0x10000) {
-        fprintf(stderr, "qemu: could not load PPC bios '%s' (%d)\n%m\n",
-                buf, ret);
-        exit(1);
-    }
-#endif
+    cpu_calibrate_ticks();
 
     /* terminal init */
     if (nographic) {
@@ -3535,31 +1181,14 @@ int main(int argc, char **argv)
         dumb_display_init(ds);
 #endif
     }
-    /* init basic PC hardware */
-    register_ioport_write(0x80, 1, ioport80_write, 1);
 
-    vga_initialize(ds, phys_ram_base + ram_size, ram_size, 
-             vga_ram_size);
-#if defined (TARGET_I386)
-    cmos_init();
-#endif
-    pic_init();
-    pit_init();
-    serial_init();
-#if defined (TARGET_I386)
-    ne2000_init();
-#endif
-    ide_init();
-    kbd_init();
-    AUD_init();
-    DMA_init();
-#if defined (TARGET_I386)
-    SB16_init();
-#endif
-#if defined (TARGET_PPC)
-    PPC_end_init();
+#if defined(TARGET_I386)
+    pc_init(ram_size, vga_ram_size, boot_device,
+            ds, fd_filename, snapshot,
+            kernel_filename, kernel_cmdline, initrd_filename);
+#elif defined(TARGET_PPC)
+    ppc_init();
 #endif
-    fdctrl_register((unsigned char **)fd_filename, snapshot, boot_device);
 
     /* setup cpu signal handlers for MMU / self modifying code handling */
 #if !defined(CONFIG_SOFTMMU)
diff --git a/vl.h b/vl.h
index 35962d1..026a5de 100644
--- a/vl.h
+++ b/vl.h
@@ -29,21 +29,25 @@
 /* vl.c */
 extern int reset_requested;
 extern int64_t ticks_per_sec;
+extern int pit_min_timer_count;
 
 typedef void (IOPortWriteFunc)(struct CPUState *env, uint32_t address, uint32_t data);
 typedef uint32_t (IOPortReadFunc)(struct CPUState *env, uint32_t address);
 
 int register_ioport_read(int start, int length, IOPortReadFunc *func, int size);
 int register_ioport_write(int start, int length, IOPortWriteFunc *func, int size);
-void pic_set_irq(int irq, int level);
 int64_t cpu_get_ticks(void);
+uint64_t muldiv64(uint64_t a, uint32_t b, uint32_t c);
 
-void kbd_put_keycode(int keycode);
+void net_send_packet(int net_fd, const uint8_t *buf, int size);
 
-#define MOUSE_EVENT_LBUTTON 0x01
-#define MOUSE_EVENT_RBUTTON 0x02
-#define MOUSE_EVENT_MBUTTON 0x04
-void kbd_mouse_event(int dx, int dy, int dz, int buttons_state);
+void hw_error(const char *fmt, ...);
+
+int load_image(const char *filename, uint8_t *addr);
+extern const char *bios_dir;
+
+void pstrcpy(char *buf, int buf_size, const char *str);
+char *pstrcat(char *buf, int buf_size, const char *s);
 
 /* block.c */
 typedef struct BlockDriverState BlockDriverState;
@@ -139,4 +143,78 @@ void fdctrl_init (int irq_lvl, int dma_chann, int mem_mapped, uint32_t base,
                   char boot_device);
 int fdctrl_disk_change (int idx, const unsigned char *filename, int ro);
 
+/* ne2000.c */
+
+#define MAX_ETH_FRAME_SIZE 1514
+
+void ne2000_init(int base, int irq);
+int ne2000_can_receive(void);
+void ne2000_receive(uint8_t *buf, int size);
+
+extern int net_fd;
+
+/* pckbd.c */
+
+void kbd_put_keycode(int keycode);
+
+#define MOUSE_EVENT_LBUTTON 0x01
+#define MOUSE_EVENT_RBUTTON 0x02
+#define MOUSE_EVENT_MBUTTON 0x04
+void kbd_mouse_event(int dx, int dy, int dz, int buttons_state);
+
+void kbd_init(void);
+
+/* mc146818rtc.c */
+
+typedef struct RTCState {
+    uint8_t cmos_data[128];
+    uint8_t cmos_index;
+    int irq;
+} RTCState;
+
+extern RTCState rtc_state;
+
+void rtc_init(int base, int irq);
+void rtc_timer(void);
+
+/* serial.c */
+
+void serial_init(int base, int irq);
+int serial_can_receive(void);
+void serial_receive_byte(int ch);
+void serial_receive_break(void);
+
+/* i8259.c */
+
+void pic_set_irq(int irq, int level);
+void pic_init(void);
+
+/* i8254.c */
+
+#define PIT_FREQ 1193182
+
+typedef struct PITChannelState {
+    int count; /* can be 65536 */
+    uint16_t latched_count;
+    uint8_t rw_state;
+    uint8_t mode;
+    uint8_t bcd; /* not supported */
+    uint8_t gate; /* timer start */
+    int64_t count_load_time;
+    int64_t count_last_edge_check_time;
+} PITChannelState;
+
+extern PITChannelState pit_channels[3];
+
+void pit_init(void);
+void pit_set_gate(PITChannelState *s, int val);
+int pit_get_out(PITChannelState *s);
+int pit_get_out_edges(PITChannelState *s);
+
+/* pc.c */
+void pc_init(int ram_size, int vga_ram_size, int boot_device,
+             DisplayState *ds, const char **fd_filename, int snapshot,
+             const char *kernel_filename, const char *kernel_cmdline,
+             const char *initrd_filename);
+
 #endif /* VL_H */
